use std::io;

use app::App;
use crossterm::event::{self, KeyCode, KeyEventKind};
use ratatui::{style::Stylize, widgets::Paragraph, DefaultTerminal};

fn main() -> io::Result<()> {
    let mut term = ratatui::init();
    term.clear()?;

    let r = App::default().run(&mut term);
    ratatui::restore();
    r
}

mod app {

    use std::io;

    use ratatui::{DefaultTerminal, Frame};

    #[derive(Default)]
    pub struct App {
        exit: bool,
    }

    impl App {
        pub fn run(&mut self, terminal: &mut DefaultTerminal) -> io::Result<()> {
            while !self.exit {
                terminal.draw(|frame| self.draw(frame))?;
                self.handle_events()?;
            }
            Ok(())
        }

        fn draw(&self, frame: &mut Frame) {
            todo!()
        }

        fn handle_events(&mut self) -> io::Result<()> {
            todo!()
        }
    }
}
